unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TFormMain = class(TForm)
    Button1: TButton;
    FileEdit: TLabeledEdit;
    Login: TLabeledEdit;
    Password: TLabeledEdit;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure OnPost(const MethodName: string; SOAPRequest: TStream);
  end;

var
  FormMain: TFormMain;

implementation

uses
  {PushDataService,} serviceBus, SoapHTTPClient, IdCoderMIME;

{$R *.dfm}


Function FileToStr(FileName: String): String;
var
  f : File;
begin
  if Pos(':\',FileName)=0 then begin
    FileName:=ExtractFilePath(ParamStr(0))+'\'+FileName;
  end;
  AssignFile(f,FileName);
  ReSet(f,1);
  SetLength(Result,FileSize(f));
  BlockRead(f,Result[1],FileSize(f));
  CloseFile(f);
end;

Procedure StrToFile(FileName,Str: AnsiString);
var
  f : TextFile;
  FN : string;
begin
  FN:=String(FileName);
  if Pos(':\',FN)=0 then begin
    FN:=ExtractFilePath(ParamStr(0))+FN;
  end;
  AssignFile(f,FN);
  ReWrite(f);
  Write(f,Str);
  CloseFile(f);
end;


procedure TFormMain.Button1Click(Sender: TObject);
var
  WS       : PushDataServiceSoap;
  Res      : ResponsePushData;
  Stream   : TMemoryStream;
  Encoder  : TIdEncoderMIME;
  Data     : string;
  HTTPRIO1 : THTTPRIO;
begin
  Stream:=TMemoryStream.Create;
  Encoder:=TIdEncoderMIME.Create(Self);
  try
    Stream.LoadFromFile(FileEdit.Text);
    Data:=Encoder.Encode(Stream);
    HTTPRIO1:=THTTPRIO.create(nil);
    HTTPRIO1.URL:='http://91.219.12.29/serviceBus';
    HTTPRIO1.Service:='PushDataService';
    HTTPRIO1.Port:='PushDataServiceSoap';
    WS:=HTTPRIO1 as PushDataServiceSoap;
    HTTPRIO1.OnBeforeExecute:=onPost;
    Res:=WS.PushData('1.0',Data);
    if Res.Result then begin
      if Res.Message_<>'' then begin
        ShowMessage('  .');
      end else begin
        ShowMessage('   :'+#13#10+Res.Message_);
      end;
    end else begin
      ShowMessage(' : '+Res.Message_);
    end;
    StrToFile('result.log',Res.Message_);
    Res.Free;
  finally
  end;
end;

procedure TFormMain.OnPost(const MethodName: string; SOAPRequest: TStream);
var
  s : AnsiString;
  p : integer;
begin
  SetLength(s,SOAPRequest.Size);
  SOAPRequest.Position:=0;
  SOAPRequest.Read(s[1],SOAPRequest.Size);

  p:=Pos('<SOAP-ENV:Body>',String(s));
  if p>0 then begin
    s:=copy(s,1,p-2)+' xmlns:gis="http://Fed.edu.segment/gisdo">'#13#10+
       '   <SOAP-ENV:Header>'#13#10+
       '      <gis:Authentication>'#13#10+
       '         <gis:Login>'+AnsiString(Login.Text)+'</gis:Login>'#13#10+
       '         <gis:Password>'+AnsiString(Password.Text)+'</gis:Password>'#13#10+
       '      </gis:Authentication>'#13#10+
       '   </SOAP-ENV:Header>'+
       copy(s,p,length(s));
//    StrToFile('1.xml',s);
  end;

  SOAPRequest.Position:=0;
  SOAPRequest.Write(s[1],length(s));
  SOAPRequest.Size:=length(s);
end;

end.


